# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# documaniatv_tfm - Testing for Maintenance
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import re

from core import logger
from core import scrapertools
from core.item import Item
from servers import servertools

__channel__ = "documaniatv_tfm"
__category__ = "D"
__type__ = "generic"
__title__ = "Documania TV TfM"
__language__ = "ES"
__date__ = "17/05/2016"
__version__ = "2016051701"

host = "http://www.documaniatv.com"

def isGeneric():
    return True

def mainlist(item):
    logger.info("[documaniatv_tfm.py] mainlist")
    return [
        Item(channel=__channel__, action="fichas", title="Novedades", url=host + "/newvideos.html"),
        Item(channel=__channel__, action="fichas", title="Top documentales", url=host + "/topvideos.html"),
        Item(channel=__channel__, action="submainlist", title="Categorías y canales", url=host + "/browse.html"),
        Item(channel=__channel__, action="submainlist", title="Top series documentales", url=host + "/top-series-documentales-html"),
        Item(channel=__channel__, action="search", title="Buscar...")
    ]

def submainlist(item):
    logger.info("[documaniatv_tfm.py] submainlist")
    itemlist = []

    data = scrapertools.cache_page(item.url)

    if '/top-' in item.url:
        patron = '<li.*?"(' + host + '/tags/[^"]+)".*?title="([^"]+).*?li>'
    else:
        patron = '<li.*?"(' + host + '/browse-[^"]+)".*?alt="([^"]+)".*?li>'

    url = ""
    matches = scrapertools.find_multiple_matches(data, patron)
    for scrapedurl, scrapedtitle in matches:
        if url != scrapedurl:
            itemlist.append( Item(channel=__channel__, action="fichas", title=scrapedtitle.capitalize(), url=scrapedurl,) )
        url = scrapedurl

    return sorted(itemlist, key=lambda Item: Item.title)

def search(item, texto):
    logger.info("[documaniatv_tfm.py] search")

    item.url = host + "/search.php?keywords=" + texto

    try:
        return fichas(item)

    # Se captura la excepción, para no interrumpir al buscador global si un canal falla
    except:
        import sys
        for line in sys.exc_info():
            logger.error( "%s" % line )
        return []

def fichas(item):
    logger.info("[documaniatv_tfm.py] novedades")
    itemlist = []

    data = scrapertools.cache_page(item.url)

    patron = '"' + host + '/.*?-\w+_([^\.]+)\.html" title="([^"]+)">.*?"(' + host + '/.*?thumbs[^"]+)"'

    matches = scrapertools.find_multiple_matches(data, patron)
    for scrapedurl, scrapedtitle, scrapedthumbnail in matches:
        itemlist.append( Item(channel=__channel__, action="play", title=scrapedtitle, url=scrapedurl, thumbnail=scrapedthumbnail) )

    next_page_url = scrapertools.find_single_match(data, '<a href="([^"]+)">&raquo;</a>')
    if next_page_url != "":
        itemlist.append( Item(channel=__channel__, action="fichas", title=">> Pagina siguiente", url=host + "/" + next_page_url) )

    return itemlist

def play(item):
    logger.info("[documaniatv_tfm.py] play")

    url = scrapertools.get_match(
        scrapertools.cache_page(host + "/embed/" + item.url),
        'iframe src="([^"]+)"'
    )

    url = scrapertools.get_match(
        scrapertools.cache_page(url),
        'file:\s*"([^"]+)"'
    )

    return [
        Item(channel=__channel__, action="play", title=item.title, url=url, server="Directo", fulltitle=item.title, thumbnail=item.thumbnail)
    ]
